package com.flyfish.framework.r2dbc.repository.fill;

import com.flyfish.framework.domain.base.Domain;
import org.springframework.data.r2dbc.convert.R2dbcConverter;
import org.springframework.data.relational.repository.query.RelationalEntityInformation;
import reactor.core.publisher.Mono;

/**
 * r2dbc引用填充
 *
 * @author wangyu
 */
@FunctionalInterface
public interface R2dbcReferenceFiller<T extends Domain> {

    /**
     * 创建新的填充器
     *
     * @param <T> 泛型
     * @return 结果
     */
    static <T extends Domain> R2dbcReferenceFiller<T> newFiller(RelationalEntityInformation<T, String> entityInformation, R2dbcConverter converter) {
        return new SimpleR2dbcReferenceFiller<>(entityInformation, converter);
    }

    /**
     * 填充附加值
     *
     * @param bean 实体信息
     * @return 结果
     */
    Mono<T> fill(T bean);
}
